package ovh.herisson.Clyde.Services;

import org.springframework.stereotype.Service;
import ovh.herisson.Clyde.Repositories.*;
import ovh.herisson.Clyde.Tables.*;

import java.sql.SQLOutput;
import java.util.Map;

@Service
public class LessonRequestService {
    private final LessonChangesRequestRepository lessonChangesRepo;

    private final UserRepository userRepo;

    private final LessonRepository lessonRepo;

    private final LessonService lessonServ;

    private final ScheduleLessonRepository scheduleLessonRepo;

    private final ScheduleRepository scheduleRepository;

    private final ScheduleLessonService scheduleLessonService;

    private final CourseRepository courseRepository;
    public LessonRequestService(LessonChangesRequestRepository lessonChangesRepo,
                                UserRepository userRepo, LessonRepository lessonRepo,
                                LessonService lessonServ, ScheduleLessonRepository scheduleLessonRepo, ScheduleRepository scheduleRepository, ScheduleLessonService scheduleLessonService, CourseRepository courseRepository) {
        this.lessonChangesRepo = lessonChangesRepo;
        this.userRepo = userRepo;
        this.lessonRepo = lessonRepo;
        this.lessonServ = lessonServ;
        this.scheduleLessonRepo = scheduleLessonRepo;
        this.scheduleRepository = scheduleRepository;
        this.scheduleLessonService = scheduleLessonService;
        this.courseRepository = courseRepository;
    }
    public Iterable<LessonChangesRequest> findOwnRequests(User user){
        return lessonChangesRepo.findOwnRequests(user);
    }
    public LessonChangesRequest save(LessonChangesRequest lessonRequest){
        return lessonChangesRepo.save(lessonRequest);
    }
    public LessonChangesRequest findById(long id){
        return lessonChangesRepo.findById(id);
    }
    public Iterable<LessonChangesRequest> getAll(){return lessonChangesRepo.findAll();}

    public boolean modifyCreateRequestState(LessonChangesRequest lessonRequest, RequestState state, String local ){
        if(lessonRequest == null || state == lessonRequest.getState()  || state == null){
            return false;}
        if (state == RequestState.Accepted){
            Course course = courseRepository.findById(lessonRequest.getCourse().getCourseID());
            if(courseRepository.findById(lessonRequest.getCourse().getCourseID())==null|| local == null){
                return false;}
            Lesson lesson = new Lesson(
                    course,
                    lessonRequest.getLessonStart(),
                    lessonRequest.getLessonEnd(),
                    lessonRequest.getColor(),
                    local,
                    lessonRequest.getLessonType());
            lesson = lessonRepo.save(lesson);
            scheduleLessonService.saveToAllSchedule(lesson);
            }
        lessonRequest.setState(state);
        save(lessonRequest);
        return true;
    }

    public boolean modifyChangeRequestState(Map<String, Object> updates, long lessonId,RequestState state){
        if(state == RequestState.Accepted){
            System.out.println(updates.toString());

            Lesson lesson = lessonServ.findById(lessonId);
            return lessonServ.modifyData(lesson.getLessonID(),updates);
        }
        return true;
    }

    public void modifyDeleleRequest(LessonChangesRequest lessonChangesRequest, RequestState state){
        if(state == RequestState.Accepted){
            lessonServ.delete(lessonServ.findById(lessonChangesRequest.getLesson()));
            lessonChangesRequest.setState(state);}
    }



    public void delete (LessonChangesRequest toDelete) {
        lessonChangesRepo.delete(toDelete);
    }
}
